-- Synchroniseur.ms
-- Par Antoine Pasquay
-- Version 1.3
-- Created On: 20/12/2002
-- Modified On: 18/01/2003
-- tested using Max 4.0
-------------------------------------------------------------------------------
-- SYNCHRONISEUR 
-------------------------------------------------------------------------------
-- Fichier requis : Vehicule.bmp
-------------------------------------------------------------------------------
-- Description: 
-- Synchroniseur sert a crer des roues qui tourne en synchronisation avec les 
-- chenilles cres par Chenilleur.
--
-- Historique :
-- V 0.8 : Bta : Impossible de changer ou supprimer le Chemin et/ou le Leader
-- V 0.9 : Bta : Ajout de : Intrieur/extrieur, Forc temps rel.
-- V 1.0 : Debugg :possibilit de renommer ou supprimer le chemin et/ou le Leader.
-- V 1.1 : Ajout de : Parent  Chemin.
-- V 1.2 : Orientation correcte par rapport au parent.
-- V 1.3 : Prend en charge les contrleur trajectoire inclut dans un contrleur liste.
--		 : Dcalage de la valeur du rayon sur trajectoire.
-- V 1.4 : Cration des roues de chenille  l'emplacement courant du Leader.
-- a faire : taux de patinage animable; cration d'un roue autonome.
--------------------------------------------
--     Fonctions
--------------------------------------------
fn is_path obj =
(
    local isALine, isASpline;
	isASpline = (superclassOf obj == Shape);
    return (isASpline);	
)


--------------------------------------------
--   synchroniseur
--------------------------------------------
rollout Synchroniseur "Paramtres"
(
	-------------------------------
	group "Objet source"
	(
		pickbutton p_traj "Choisir Chemin" width:150 filter: is_path
		label o1 "Longueur : ------- "
		pickbutton p_lead "Choisir Leader" width:150
	)
	group "Roue"
	(
		spinner diam "Rayon :" range: [0,5000,25] fieldwidth:45 align:#right type: #float
		checkbox ioe  "Inverser rotation" align:#left
		checkbox ofset "Ajouter rayon" checked: true
	)
	group "Parent"
	(
		radiobuttons parent  labels:#("Chemin ","Leader ", "Aucun ") default:1 columns: 2 
	)
	group "Gnral"
	(
		checkbox ftrr "Forcer Temps rel" checked: true
		checkbox gdr "Geler diamtre" checked: false
		Button cr "Crer roue" width:150 enabled: false height: 25
	)
	
	--------
	on parent changed state do
	(
	if parent.state == 3 then ofset.enabled = false else ofset.enabled = true
	)
	--------
	on Sync open do
	(
		global ch1, ch2
		Global traj, lead
		global Pcont = ""
		global axe = undefined
		ch1 = ch2 = 0
		traj = undefined
		lead = undefined
	)
	--------
	on p_traj picked traj do
	(
		traj = p_traj.object
		p_traj.text = traj.name
		o1.text = "Longueur : "+(curvelength traj)as string
		ch1 = 1
		if (ch1+ch2 == 2 ) then cr.enabled = true
	)
	--------
	on p_lead picked lead do
	(
	lead = p_lead.object
	cont = lead.pos.Controller
	
	case of
	(
		(isKindOf cont Path_Constraint == true) :
			(
			p_lead.text = lead.name
			ch2 = 1
			if (ch1+ch2 == 2 ) then cr.enabled = true
			axe = cont.axis
			cont.constantVel = true
			Pcont = ""
			)
		
		(isKindOf cont position_list and classOf cont[ListCtrl.GetActive cont].controller == Path_Constraint ) :
			(
			p_lead .text = lead.name
			ch2 = 1
			if (ch1+ch2 == 2 ) then cr.enabled = true
			NumC = ListCtrl.GetActive cont
			Pname = ListCtrl.setName cont NumC "Leader_Path"
			axe = cont.Leader_Path.controller.axis
			cont.Leader_Path.controller.constantVel = true
			Pcont = ".Leader_Path"
			)
		default :
			(
				messagebox "Cet objet n'a pas de contrleur de trajectoire, ou bien\nil n'est pas dfinis sur actif!"
				p_lead.text = "Pick Leader"
			)
		)
	)
	-------------------------------
	on cr pressed do
	(
	undo "Synchroniseur" on
		(
		ld = p_lead.object
		id_ld = ld.handle
		tj = p_traj.object
		id_tj = tj.handle 
		
		rs = circle name: (uniquename "Roue_") radius: diam.value pos: tj.pos wirecolor: blue
		if gdr.checked == true then
			(
			rs.radius.controller = float_script ()
			rs.radius.controller.script = diam.value as string
			)
		id_rs = rs.handle
		rs.rotation.controller = euler_xyz()
		
		str = ("ld = (maxops.getNodeByHandle "+id_ld as string+")\n")
		str += ("tj = (maxops.getNodeByHandle "+id_tj as string+")\n")
		str += ("rs = (maxops.getNodeByHandle "+id_rs as string+")\n")
		str += ("if ld == undefined or tj == undefined or rs == undefined then 0 else (\n")
		str += if ftrr.checked == true  then ("dependsOn rs ld tj\n")else ("")
		str += if gdr.checked == true then ("d = "+(diam.value*2) as string+"\n") else ("d = rs.radius*2 \n")
		str += ("L = (curveLength tj) \n")
		str += ("P = ld.pos.controller"+Pcont+".percent.controller.value \n");
					
		case parent.state of
		(
		
		1:
			(
			dpr = dummy pos: ld.pos dir: ld.dir name: (uniquename "Porte_roue")
			rs.pos = ld.pos
			rs.parent = dpr
			dpr.parent = p_traj.object
			in coordsys parent rs.rotation.x = 0
			in coordsys parent rs.rotation.y = 0
			in coordsys parent rs.rotation.z = 0

			if ofset.checked == true then in coordsys parent move rs [diam.value,0,0]
			str += if ioe.checked == true then ("-degToRad(L/(pi * d))*3.6*P )") else ("degToRad(L/(pi * d))*3.6*P )")
			rs.rotation.z_rotation.controller = float_script ()
			rs.rotation.z_rotation.controller.script = str
			)
		2:
			(
			rs.parent = ld
			in coordsys parent rs.rotation.x = 0
			in coordsys parent rs.rotation.y = 0
			in coordsys parent rs.rotation.z = 0
			
				case of
				(
					(axe == 0):
					(
						if ofset.checked == true then in coordsys parent rs.pos = [0,0,(diam.value)] else in coordsys parent rs.pos = [0,0,0]
						str += if ioe.checked == true then ("-degToRad(L/(pi * d))*3.6*P )") else ("degToRad(L/(pi * d))*3.6*P )")
						rs.rotation.y_rotation.controller = float_script ()
						rs.rotation.y_rotation.controller.script = str
						rot = eulerangles 90 0 0
						in coordsys parent rotate rs rot
	
					)
					(axe == 1):
					(
						if ofset.checked == true then in coordsys parent rs.pos = [0,0,(diam.value)] else in coordsys parent rs.pos = [0,0,0]
						str += if ioe.checked == true then ("degToRad(L/(pi * d))*3.6*P )") else ("-degToRad(L/(pi * d))*3.6*P )")
						rs.rotation.x_rotation.controller = float_script ()
						rs.rotation.x_rotation.controller.script = str
						rot = eulerangles 0 90 0
						in coordsys parent rotate rs rot
	
					)
					(axe == 2):
					(
						if ofset.checked == true then in coordsys parent rs.pos = [-(diam.value),0,0] else in coordsys parent rs.pos = [0,0,0]
						str += if ioe.checked == true then ("-degToRad(L/(pi * d))*3.6*P )") else ("degToRad(L/(pi * d))*3.6*P )")
						rs.rotation.y_rotation.controller = float_script ()
						rs.rotation.y_rotation.controller.script = str
						rot = eulerangles 90 0 0
						in coordsys parent rotate rs rot
					)
				)
			)
		3 :
			(
			str += if ioe.checked == true then ("-degToRad(L/(pi * d))*3.6*P )") else ("degToRad(L/(pi * d))*3.6*P )")
			rs.rotation.z_rotation.controller = float_script ()
			rs.rotation.z_rotation.controller.script = str
			)
		)
		select rs
		)
	)
-------------------------------
)
--------------------------------------------
--               A Propos
--------------------------------------------
rollout Propos "A propos."
(
	group ""
	(
	bitmap logo filename: "Chenilleur.BMP"
	label l1 "Synchroniseur Version 1.2"
	label l2 "Auteur: Antoine PASQUAY"
	hyperlink label_l09 "www.athanaze.com" align:#center address:"http://www.athanaze.fr.st" color:(color 70 70 255) hoverColor:(color 230 63 63)
	label l10 "E-mail :"
	hyperlink label_l11 "athanaze@fr.st" align:#center address:"mailto:athanaze@fr.st" color:(color 70 70 255) hoverColor:(color 230 63 63)
	)
)

--------------------------------------------
--             Flotteur
--------------------------------------------

SynchroniseurFloater = newRolloutFloater "Synchroniseur V1.4" 200 427
addrollout Synchroniseur SynchroniseurFloater 
addrollout Propos SynchroniseurFloater rolledup: true